# Fat German Productions 2011

# This program is SpongWare.
# The use of SpongWare is entirely according to the following conditions:
# 1) You may use it or not, I don't care. Just don't winge at me, I hate that
# 2) It is provided 'as is'. Nobody is responsible for anything it might or might not do. 
#    Take your lawyers and stuff 'em up your USB port
# 3) You may distribute it freely, although I would advise against printing it out and 
#    throwing it out of the window, that stuff gets you fined
# 4) You may alter it if you wish, and distribute the altered version if you wish but 
#    you must include this license
# 5) Before installing this software, smile at someone you like
# 6) There is no rule 6
# 7) This notice must be included with any copy of the software you distribute
# 8) Adherence to 'coding standards' is to be regarded with suspicion. 
# 9) Let me reiterate clause 2. If this program goes wrong in any way, for example
#    it deletes all your data or perhaps it wipes the entire internet overnight and 
#    leaves the world a dead place, nobody is responsible. Deal with it.
#    Sometimes, shit happens

# fatgerman@gmail.com

from PyQt4 import QtGui
from PyQt4.QtCore import *
from PyQt4.QtGui import *
from PyKDE4.plasma import Plasma
from PyKDE4.kdeui import KIcon

class TardisThing(QGraphicsWidget):

    def __init__(self,parent,args=None):
        QGraphicsWidget.__init__(self)
        self.applet = parent.applet
        self.setMinimumSize(QSizeF(300, 140))
        self.parent = parent
        
    def init(self):
        self.layout = QGraphicsGridLayout(self)
        
        if (self.parent.canRun == False):
            self.runbutton = Plasma.IconWidget(self)
            self.runbutton.setDrawBackground(False);
            self.runbutton.setOrientation(Qt.Vertical);
            self.runbutton.setIcon(KIcon("dialog-error"));        
            self.runbutton.setMinimumSize(QSizeF(48, 48))
            self.layout.addItem(self.runbutton, 0, 0, 5, 1)
            self.lab = Plasma.Label(self)
            self.lab.setText("Another TARDIS widget seems to be running")
            self.layout.addItem(self.lab, 0, 1)            
            self.lab2 = Plasma.Label(self)
            self.lab2.setText("You can't have more than one TARDIS")
            self.layout.addItem(self.lab2, 1, 1)
            self.lab3 = Plasma.Label(self)
            self.lab3.setText("If this is the only TARDIS then please:")
            self.layout.addItem(self.lab3, 2, 1)
            self.lab4 = Plasma.Label(self)
            self.lab4.setText("Remove all TARDIS widgets from your desktop")
            self.layout.addItem(self.lab4, 3, 1)
            self.lab5 = Plasma.Label(self)
            self.lab5.setText("Delete the file /tmp/tardispipe")
            self.layout.addItem(self.lab5, 4, 1)
            self.lab6 = Plasma.Label(self)
            self.lab6.setText("Re-add one TARDIS widget")
            self.layout.addItem(self.lab6, 5, 1)
        else:
            self.lab = Plasma.Label(self)
            self.lab.setText("TARDIS is")
            self.layout.addItem(self.lab, 0, 0)
            self.checkBox = Plasma.Label(self)
            self.checkBox.setText("OFF")
            self.layout.addItem(self.checkBox, 0, 1)
                    
            self.label3 = Plasma.Label(self)
            self.label3.setText("Status")
            self.layout.addItem(self.label3, 1, 0)
            self.label = Plasma.Label(self)
            self.label.setText("Idle")
            self.label.setWordWrap(False)
            self.layout.addItem(self.label, 1, 1)

            self.infolabel = Plasma.Label(self)
            self.infolabel.setWordWrap(False)
            self.layout.addItem(self.infolabel, 2, 0, 1, 2)
            self.lastlabel = Plasma.Label(self)
            self.lastlabel.setText("Last Backup: None")
            self.layout.addItem(self.lastlabel, 3, 0, 1, 2)
            
            self.sep = Plasma.Separator(self);
            self.sep.setOrientation(Qt.Horizontal);
            self.layout.addItem(self.sep, 4, 0, 1, 2);
            
            self.runbutton = Plasma.IconWidget(self)
            self.runbutton.setDrawBackground(True);
            self.runbutton.setOrientation(Qt.Horizontal);
            self.runbutton.setText("Backup Now...")
            self.runbutton.setMaximumSize(QSizeF(148, 48))            
            self.layout.addItem(self.runbutton, 5, 1)
            
            self.layout.setColumnAlignment(1, Qt.AlignLeft)
            self.layout.setColumnFixedWidth(0, 80)
        
    def updateCheckBox(self,isEnabled):
        if (isEnabled == True):
            self.checkBox.setText("ON")
        else:
            self.checkBox.setText("OFF")

    def updateLabel(self,text):
        self.label.setText(text)
            
    def updateLastDate(self, lastdate):
        s = lastdate.partition(':')
        if (s[0] == "Most Recent Backup"):
            self.lastlabel.setText("Last Backup: "+s[2].rstrip())
        
    def updateInfo(self, text):
        # Trim the text so it fits the on-screen dimensions of the label
        fm = QFontMetrics(QFont(self.infolabel.font()))
        t = fm.elidedText(QString(text.rstrip()), Qt.ElideLeft, self.infolabel.size().width())
        self.infolabel.setText(t)
        